// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package http

import (
	"context"
	"form3/payment/internal/domain"
	"sync"
)

var (
	lockPaymentServiceMockCreate sync.RWMutex
	lockPaymentServiceMockDelete sync.RWMutex
	lockPaymentServiceMockFind   sync.RWMutex
	lockPaymentServiceMockList   sync.RWMutex
	lockPaymentServiceMockUpdate sync.RWMutex
)

// Ensure, that PaymentServiceMock does implement PaymentService.
// If this is not the case, regenerate this file with moq.
var _ domain.PaymentService = &PaymentServiceMock{}

// PaymentServiceMock is a mock implementation of PaymentService.
//
//     func TestSomethingThatUsesPaymentService(t *testing.T) {
//
//         // make and configure a mocked PaymentService
//         mockedPaymentService := &PaymentServiceMock{
//             CreateFunc: func(ctx context.Context, payment domain.Payment) (string, error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(ctx context.Context, id string) error {
// 	               panic("mock out the Delete method")
//             },
//             FindFunc: func(ctx context.Context, id string) (domain.Payment, error) {
// 	               panic("mock out the Find method")
//             },
//             ListFunc: func(ctx context.Context, pagination domain.Pagination) ([]domain.Payment, domain.Pagination, error) {
// 	               panic("mock out the List method")
//             },
//             UpdateFunc: func(ctx context.Context, payment domain.Payment) error {
// 	               panic("mock out the Update method")
//             },
//         }
//
//         // use mockedPaymentService in code that requires PaymentService
//         // and then make assertions.
//
//     }
type PaymentServiceMock struct {
	// CreateFunc mocks the Create method.
	CreateFunc func(ctx context.Context, payment domain.Payment) (string, error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(ctx context.Context, id string) error

	// FindFunc mocks the Find method.
	FindFunc func(ctx context.Context, id string) (domain.Payment, error)

	// ListFunc mocks the List method.
	ListFunc func(ctx context.Context, pagination domain.Pagination) ([]domain.Payment, domain.Pagination, error)

	// UpdateFunc mocks the Update method.
	UpdateFunc func(ctx context.Context, payment domain.Payment) error

	// calls tracks calls to the methods.
	calls struct {
		// Create holds details about calls to the Create method.
		Create []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Payment is the payment argument value.
			Payment domain.Payment
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
		}
		// Find holds details about calls to the Find method.
		Find []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
		}
		// List holds details about calls to the List method.
		List []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Pagination is the pagination argument value.
			Pagination domain.Pagination
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Payment is the payment argument value.
			Payment domain.Payment
		}
	}
}

// Create calls CreateFunc.
func (mock *PaymentServiceMock) Create(ctx context.Context, payment domain.Payment) (string, error) {
	if mock.CreateFunc == nil {
		panic("PaymentServiceMock.CreateFunc: method is nil but PaymentService.Create was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Payment domain.Payment
	}{
		Ctx:     ctx,
		Payment: payment,
	}
	lockPaymentServiceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockPaymentServiceMockCreate.Unlock()
	return mock.CreateFunc(ctx, payment)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedPaymentService.CreateCalls())
func (mock *PaymentServiceMock) CreateCalls() []struct {
	Ctx     context.Context
	Payment domain.Payment
} {
	var calls []struct {
		Ctx     context.Context
		Payment domain.Payment
	}
	lockPaymentServiceMockCreate.RLock()
	calls = mock.calls.Create
	lockPaymentServiceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *PaymentServiceMock) Delete(ctx context.Context, id string) error {
	if mock.DeleteFunc == nil {
		panic("PaymentServiceMock.DeleteFunc: method is nil but PaymentService.Delete was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
	}{
		Ctx: ctx,
		ID:  id,
	}
	lockPaymentServiceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockPaymentServiceMockDelete.Unlock()
	return mock.DeleteFunc(ctx, id)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockedPaymentService.DeleteCalls())
func (mock *PaymentServiceMock) DeleteCalls() []struct {
	Ctx context.Context
	ID  string
} {
	var calls []struct {
		Ctx context.Context
		ID  string
	}
	lockPaymentServiceMockDelete.RLock()
	calls = mock.calls.Delete
	lockPaymentServiceMockDelete.RUnlock()
	return calls
}

// Find calls FindFunc.
func (mock *PaymentServiceMock) Find(ctx context.Context, id string) (domain.Payment, error) {
	if mock.FindFunc == nil {
		panic("PaymentServiceMock.FindFunc: method is nil but PaymentService.Find was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
	}{
		Ctx: ctx,
		ID:  id,
	}
	lockPaymentServiceMockFind.Lock()
	mock.calls.Find = append(mock.calls.Find, callInfo)
	lockPaymentServiceMockFind.Unlock()
	return mock.FindFunc(ctx, id)
}

// FindCalls gets all the calls that were made to Find.
// Check the length with:
//     len(mockedPaymentService.FindCalls())
func (mock *PaymentServiceMock) FindCalls() []struct {
	Ctx context.Context
	ID  string
} {
	var calls []struct {
		Ctx context.Context
		ID  string
	}
	lockPaymentServiceMockFind.RLock()
	calls = mock.calls.Find
	lockPaymentServiceMockFind.RUnlock()
	return calls
}

// List calls ListFunc.
func (mock *PaymentServiceMock) List(ctx context.Context, pagination domain.Pagination) ([]domain.Payment, domain.Pagination, error) {
	if mock.ListFunc == nil {
		panic("PaymentServiceMock.ListFunc: method is nil but PaymentService.List was just called")
	}
	callInfo := struct {
		Ctx        context.Context
		Pagination domain.Pagination
	}{
		Ctx:        ctx,
		Pagination: pagination,
	}
	lockPaymentServiceMockList.Lock()
	mock.calls.List = append(mock.calls.List, callInfo)
	lockPaymentServiceMockList.Unlock()
	return mock.ListFunc(ctx, pagination)
}

// ListCalls gets all the calls that were made to List.
// Check the length with:
//     len(mockedPaymentService.ListCalls())
func (mock *PaymentServiceMock) ListCalls() []struct {
	Ctx        context.Context
	Pagination domain.Pagination
} {
	var calls []struct {
		Ctx        context.Context
		Pagination domain.Pagination
	}
	lockPaymentServiceMockList.RLock()
	calls = mock.calls.List
	lockPaymentServiceMockList.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *PaymentServiceMock) Update(ctx context.Context, payment domain.Payment) error {
	if mock.UpdateFunc == nil {
		panic("PaymentServiceMock.UpdateFunc: method is nil but PaymentService.Update was just called")
	}
	callInfo := struct {
		Ctx     context.Context
		Payment domain.Payment
	}{
		Ctx:     ctx,
		Payment: payment,
	}
	lockPaymentServiceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockPaymentServiceMockUpdate.Unlock()
	return mock.UpdateFunc(ctx, payment)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockedPaymentService.UpdateCalls())
func (mock *PaymentServiceMock) UpdateCalls() []struct {
	Ctx     context.Context
	Payment domain.Payment
} {
	var calls []struct {
		Ctx     context.Context
		Payment domain.Payment
	}
	lockPaymentServiceMockUpdate.RLock()
	calls = mock.calls.Update
	lockPaymentServiceMockUpdate.RUnlock()
	return calls
}
